using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;

 
public class ViewModel : INotifyPropertyChanged
    {
        public ObservableCollection<GridData> Data;
        private GridData _activeItem;

        public GridData ActiveItem
        {
            get { return _activeItem; }
            set
            {
                if (_activeItem != value)
                {
                    _activeItem = value;
                    OnPropertyChanged("ActiveItem");
                }
            }
        }

        int cnt = 0;

        public ViewModel()
        {
            CreateData();
           
           
        }

       

        private string[] names = { "John", "Kim", "Sandy", "Mark", "Josh", "Jim", "Sam", "Mary", 
                                     "Harry", "Sue", "Chris", "Joe", "Carl" };
        private string[] recDescs = { "Test", "Duplicate", "Standard", "Trial", "Expired", "New", "History" };
        private void CreateData()
        {
            Random r = new Random();
            Data = new ObservableCollection<GridData>();
            for (int i = 0; i < 20; i++)
            {
                Data.Add(new GridData()
                {
                    ID = i,
                    Name = names[r.Next(13)],
                    RecDesc = recDescs[r.Next(7)],
                    RecDate = DateTime.Today.AddDays(r.Next(10))
                });
            }

            cnt = 19;

            ActiveItem = Data.FirstOrDefault();

           
        }

        public void AddData()
        {
            
            cnt++;
            Random r = new Random();
            Data.Add(new GridData()
            {
                ID = cnt,
                Name = names[r.Next(13)],
                RecDesc = recDescs[r.Next(7)],
                RecDate = DateTime.Today.AddDays(r.Next(10))
            });
        }

        public void UpdateData()
        {
           
            Random r = new Random();
            int recID = r.Next(cnt - 1);
            GridData gd = (from rec in Data
                          where rec.ID == recID
                          select rec).FirstOrDefault();


            
            gd.RecDesc = gd.RecDesc + " - Updated";
            gd.RecDate = DateTime.Today.AddDays(r.Next(10));

            
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

    }
    public class GridData : INotifyPropertyChanged
    {
        
        private int id;
        private string name;
        private DateTime recDt;
        private string rec_desc;


        public int ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                    OnPropertyChanged("ID");
                }
            }
        }

        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                    OnPropertyChanged("Name");
                }
            }
        }

        public string RecDesc
        {
            get { return rec_desc; }
            set
            {
                if (rec_desc != value)
                {
                    rec_desc = value;
                    OnPropertyChanged("RecDesc");
                }
            }
        }

        public DateTime RecDate
        {
            get { return recDt; }
            set
            {
                if (recDt != value)
                {
                    recDt = value;
                    OnPropertyChanged("RecDate");
                }
            }
        }



        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }